/* mime-disposition-type.c generated by valac 0.26.1, the Vala compiler
 * generated from mime-disposition-type.vala, do not modify */

/* Copyright 2013-2014 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define GEARY_MIME_TYPE_DISPOSITION_TYPE (geary_mime_disposition_type_get_type ())

typedef enum  {
	GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED = -1,
	GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT = 0,
	GEARY_MIME_DISPOSITION_TYPE_INLINE = 1
} GearyMimeDispositionType;



GType geary_mime_disposition_type_get_type (void) G_GNUC_CONST;
GearyMimeDispositionType geary_mime_disposition_type_deserialize (const gchar* str, gboolean* is_unknown);
gboolean geary_string_is_empty_or_whitespace (const gchar* str);
gchar* geary_mime_disposition_type_serialize (GearyMimeDispositionType self);
GearyMimeDispositionType geary_mime_disposition_type_from_int (gint i);


/**
     * Convert the disposition-type field into an internal representation.
     *
     * Empty or blank fields result in {@link UNSPECIFIED}.  Unknown fields are converted to
     * {@link ATTACHMENT} as per RFC 2183 Section 2.8.  However, since the caller may want to
     * make a decision about unknown vs. unspecified type fields, is_unknown is returned as well.
     */
GearyMimeDispositionType geary_mime_disposition_type_deserialize (const gchar* str, gboolean* is_unknown) {
	gboolean _vala_is_unknown = FALSE;
	GearyMimeDispositionType result = 0;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	GQuark _tmp6_ = 0U;
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	static GQuark _tmp5_label0 = 0;
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	static GQuark _tmp5_label1 = 0;
#line 33 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_vala_is_unknown = FALSE;
#line 35 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_tmp0_ = str;
#line 35 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_tmp1_ = geary_string_is_empty_or_whitespace (_tmp0_);
#line 35 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	if (_tmp1_) {
#line 36 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		result = GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED;
#line 36 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		if (is_unknown) {
#line 36 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			*is_unknown = _vala_is_unknown;
#line 68 "mime-disposition-type.c"
		}
#line 36 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		return result;
#line 72 "mime-disposition-type.c"
	}
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_tmp2_ = str;
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) (-1));
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_tmp4_ = _tmp3_;
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	g_free (_tmp4_);
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("inline")))) {
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		switch (0) {
#line 88 "mime-disposition-type.c"
			default:
			{
#line 40 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				result = GEARY_MIME_DISPOSITION_TYPE_INLINE;
#line 40 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				if (is_unknown) {
#line 40 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
					*is_unknown = _vala_is_unknown;
#line 97 "mime-disposition-type.c"
				}
#line 40 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				return result;
#line 101 "mime-disposition-type.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("attachment")))) {
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		switch (0) {
#line 107 "mime-disposition-type.c"
			default:
			{
#line 43 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				result = GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 43 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				if (is_unknown) {
#line 43 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
					*is_unknown = _vala_is_unknown;
#line 116 "mime-disposition-type.c"
				}
#line 43 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				return result;
#line 120 "mime-disposition-type.c"
			}
		}
	} else {
#line 38 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		switch (0) {
#line 126 "mime-disposition-type.c"
			default:
			{
#line 46 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				_vala_is_unknown = TRUE;
#line 48 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				result = GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 48 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				if (is_unknown) {
#line 48 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
					*is_unknown = _vala_is_unknown;
#line 137 "mime-disposition-type.c"
				}
#line 48 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
				return result;
#line 141 "mime-disposition-type.c"
			}
		}
	}
#line 32 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	if (is_unknown) {
#line 32 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		*is_unknown = _vala_is_unknown;
#line 149 "mime-disposition-type.c"
	}
}


/**
     * Returns null if value is {@link UNSPECIFIED}
     */
gchar* geary_mime_disposition_type_serialize (GearyMimeDispositionType self) {
	gchar* result = NULL;
#line 56 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	switch (self) {
#line 56 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED:
#line 163 "mime-disposition-type.c"
		{
#line 58 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			result = NULL;
#line 58 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 169 "mime-disposition-type.c"
		}
#line 56 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT:
#line 173 "mime-disposition-type.c"
		{
			gchar* _tmp0_ = NULL;
#line 61 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			_tmp0_ = g_strdup ("attachment");
#line 61 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			result = _tmp0_;
#line 61 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 182 "mime-disposition-type.c"
		}
#line 56 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_INLINE:
#line 186 "mime-disposition-type.c"
		{
			gchar* _tmp1_ = NULL;
#line 64 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			_tmp1_ = g_strdup ("inline");
#line 64 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			result = _tmp1_;
#line 64 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 195 "mime-disposition-type.c"
		}
		default:
		{
#line 67 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			g_assert_not_reached ();
#line 201 "mime-disposition-type.c"
		}
	}
}


GearyMimeDispositionType geary_mime_disposition_type_from_int (gint i) {
	GearyMimeDispositionType result = 0;
	gint _tmp0_ = 0;
#line 72 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	_tmp0_ = i;
#line 72 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
	switch (_tmp0_) {
#line 72 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_INLINE:
#line 216 "mime-disposition-type.c"
		{
#line 74 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			result = GEARY_MIME_DISPOSITION_TYPE_INLINE;
#line 74 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 222 "mime-disposition-type.c"
		}
#line 72 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED:
#line 226 "mime-disposition-type.c"
		{
#line 77 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			result = GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED;
#line 77 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 232 "mime-disposition-type.c"
		}
		default:
#line 72 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
		case GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT:
#line 237 "mime-disposition-type.c"
		{
#line 83 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			result = GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT;
#line 83 "/tmp/B.0a85ccf2-85f2-4336-bbd3-5b56418ca163/BUILD/geary-0.8.1/src/engine/mime/mime-disposition-type.vala"
			return result;
#line 243 "mime-disposition-type.c"
		}
	}
}


/**
 * A representation of a MIME Content-Disposition type field.
 *
 * Note that NONE only indicates that the Content-Disposition type field was not present.
 * RFC 2183 Section 2.8 specifies that unknown type fields should be treated as attachments,
 * which is true in this code as well.
 *
 * These values may be persisted on disk and should not be modified unless you know what
 * you're doing.  (Legacy code requires that NONE be -1.)
 *
 * See [[https://tools.ietf.org/html/rfc2183#section-2]]
 */
GType geary_mime_disposition_type_get_type (void) {
	static volatile gsize geary_mime_disposition_type_type_id__volatile = 0;
	if (g_once_init_enter (&geary_mime_disposition_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED, "GEARY_MIME_DISPOSITION_TYPE_UNSPECIFIED", "unspecified"}, {GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT, "GEARY_MIME_DISPOSITION_TYPE_ATTACHMENT", "attachment"}, {GEARY_MIME_DISPOSITION_TYPE_INLINE, "GEARY_MIME_DISPOSITION_TYPE_INLINE", "inline"}, {0, NULL, NULL}};
		GType geary_mime_disposition_type_type_id;
		geary_mime_disposition_type_type_id = g_enum_register_static ("GearyMimeDispositionType", values);
		g_once_init_leave (&geary_mime_disposition_type_type_id__volatile, geary_mime_disposition_type_type_id);
	}
	return geary_mime_disposition_type_type_id__volatile;
}



